//
//  NodeMediaEngine.m
//  node_media_client_plugin
//
//  Created by seven on 2021/2/4.
//

#import "NodeMediaEngine.h"
#import "NodeMediaClient.h"

@interface NodeMediaEngine()

 @property (assign, nonatomic) NSString *appSign;
 @property (strong, nonatomic) NodePublisher *publisher;
 @property (strong,nonatomic) NodePlayer *player;

@end

@implementation NodeMediaEngine

static NodeMediaEngine *instance = nil;

+ (instancetype)createEngineWithAppSing:(NSString *)appSign{
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        instance = [[NodeMediaEngine alloc] init];
        instance.appSign = appSign;
    });
    return instance;
}

+ (instancetype)sharedEngine{
    return instance;
}

- (void)startPreview:(UIView* _Nonnull)preView{
    _publisher = [[NodePublisher alloc] init];
    [_publisher setCameraPreview:preView cameraId:CAMERA_FRONT frontMirror:YES];
    [_publisher setAudioParamBitrate:32000 profile:AUDIO_PROFILE_HEAAC];
    [_publisher setVideoParamPreset:VIDEO_PPRESET_16X9_360 fps:15 bitrate:500000 profile:VIDEO_PROFILE_MAIN frontMirror:NO];
    [_publisher startPreview];
}

- (void)startPublishingStream:(NSString *)outputUrl{
    [_publisher setOutputUrl:outputUrl];
    [_publisher start];
}

- (void)stopPublishingStream{
    [_publisher stopPreview];
    [_publisher stop];
}

- (void)startPlayingStream:(UIView *)preView InputUrl:(NSString *)InputUrl{
    _player = [[NodePlayer alloc] init];
    [_player setPlayerView:preView];
    [_player setInputUrl:InputUrl];
    [_player start];
}

- (void)stopPlayingStream{
    [_player stop];
}

@end
