import 'package:node_media_client_plugin/node_media_defines.dart';

import 'node_media_client_plugin.dart';

class NodeMediaClientEngine {
  NodeMediaClientEngine._internal();

  static final NodeMediaClientEngine instance =
      NodeMediaClientEngine._internal();

  static Future<void> createEngine() async {
    return await NodeMediaClientPlugin.createEngine();
  }

  static Future<void> destroyEngine() async {
    return await NodeMediaClientPlugin.destroyEngine();
  }

  Future<void> startPreview({NDCanvas canvas}) async {
    return await NodeMediaClientPlugin.instance.startPreview(canvas: canvas);
  }

  Future<void> startPublishingStream(String url) async {
    return await NodeMediaClientPlugin.instance.startPublishingStream(url);
  }

  Future<void> stopPublishingStream() async {
    return await NodeMediaClientPlugin.instance.stopPublishingStream();
  }

  Future<void> stopPreview() async {
    return await NodeMediaClientPlugin.instance.stopPreview();
  }

  Future<void> startPlayingStream(String url, {NDCanvas canvas}) async {
    return await NodeMediaClientPlugin.instance
        .startPlayingStream(url, canvas: canvas);
  }

  Future<void> stopPlayingStream() async {
    return await NodeMediaClientPlugin.instance
        .stopPlayingStream();
  }

  Future<void> registerEventHandler() async {
    return await NodeMediaClientPlugin.instance
        .stopPlayingStream();
  }

  static void Function(int event, String msg) onEventCallback;
}
